package agenda;

import element.IntElement;
import element.StringPosition;

/**
 * Priority queue agenda implementation where the priority of items
 * is determined by the last two element of the item, when that elements
 * are integer elements (and not string positions), or zero when it is not.
 * 
 * The priority of an item [ ... , #e1 , #e2 ] is (stringlength+1)*#e1 + #e2.
 * 
 * @author carlos
 *
 * Created at regulus, 11-nov-2006 13:25:19
 */
public class LastTwoElementsPriorityQueueAgenda extends PriorityQueueAgenda
{
	
	/**
	 * Obtains the priority of an item.
	 * @param item
	 */
	protected int getPriority ( Object item )
	{
		Object[] theItem = (Object[]) item;
		Object lastElement = theItem[theItem.length-1];
		Object beforeLastElement = theItem[theItem.length-2];
		if ( lastElement instanceof IntElement && !( lastElement instanceof StringPosition )
				&& beforeLastElement instanceof IntElement && !( beforeLastElement instanceof StringPosition ) )
		{
			int bVal = ( (IntElement) beforeLastElement ).getValue();
			int lVal = ( (IntElement)lastElement ).getValue();
			int sentLength = StringPosition.getMaxValue();
			int val = bVal*sentLength+lVal;
			if ( val >= 0 ) return val;
			else return 0;
		}
		return 0;
	}
	
}