/*
 * Created at regulus on 28-nov-2004 13:02:49
 * as file Dot.java on package element
 */
package element;

/**
 * @author carlos
 *
 * Clase que representa el punto que aparece en las reglas de produccin de esquemas
 * como Earley o Left-Corner.
 * Created at regulus, 28-nov-2004 13:02:49
 */
public class Dot extends SpecialElement 
{

	/**
	 * Instancia nica del singleton.
	 */
	private static Dot instance = new Dot();
	
	/**
	 * Constructor privado del singleton.
	 */
	private Dot()
	{
		super(".");
		registerInstance(this);
	}
	
	/**
	 * @return La instancia nica de la clase Dot (singleton).
	 */
	public static Dot getInstance()
	{
		return instance;
	}
	
	/**
	 * Obtiene un elemento de la clase Dot a partir de la cadena que lo representa.
	 * En este caso, la implementacin de este mtodo es trivial, devolviendo siempre
	 * la instancia nica de Dot.
	 */
	public static SpecialElement fromString ( String s )
	{
		return instance;
	}
	
	/**
	 * Obtiene el cdigo Java que representa la instancia nica de Dot.
	 */
	public String getExpressionCode()
	{
		return "Dot.getInstance()";
	}
	
	
}
