/*
 * Created at denebola on 22-ago-2004 12:08:33
 *
 */
package element;
import java.util.*;
import java.util.regex.*;


public class SumOfNullablePositionsExpression extends SumOfPositionsExpression
{

    public SumOfNullablePositionsExpression ( Element[] children )
    {
        super ( children );
    }
   
    public Class getResultingClass()
    {
        return NullableStringPosition.class;
    }
    
    protected static StringPosition parsePosition ( String tok )
    {
    	return NullableStringPosition.nonGroundNullableStringPosition(tok);
    }
    
    public String getExpressionCode ( String[] memberNames )
    {
        StringBuffer result = new StringBuffer("");
        result.append(getResultingClass().getName()+".groundFromValue(false,");
        for ( int i = 0 ; i < memberNames.length ; i++ )
        {
           	result.append("+");
           	result.append("(");
           	result.append(memberNames[i]);
           	result.append(".getValue()");
           	result.append(")");
        }
        result.append(")");
        return result.toString();
    }
    
    //calculate children
    protected static List fromStringAux ( String s )
    {
        StringTokenizer st = new StringTokenizer ( s , "+-" , true );
        ArrayList children = new ArrayList();
        boolean positive = true; //signo
        while ( st.hasMoreTokens() )
        {
            String tok = st.nextToken().trim();
            if ( tok.equals("+") ) ;
            if ( tok.equals("-") ) positive = !positive;
            if ( Pattern.compile("[0-9]+").matcher(tok).matches() )
            {
                String intEltTok = tok;
                if ( !positive )
                    intEltTok = "-" + tok;
                children.add( new IntElement(Integer.valueOf(intEltTok).intValue(),true) );
                positive = true;
            }
            if ( Pattern.compile("[i-k]+").matcher(tok).matches() )
            {
                children.add( parsePosition(tok) );
                positive = true;
            }
        }
        return children;
    }
    
    public static SumOfNullablePositionsExpression nullableSumFromString ( String s )
    {
    	List children = fromStringAux(s);
        return new SumOfNullablePositionsExpression( (Element[])children.toArray(new Element[0]) );
    }


}
