@begin_elements
element.Symbol:nonGroundFromString:[A-DF-RT-Za-df-hq-z]
element.RuleWrapper:fromString:[A-Za-z \.]+->[A-Za-z \.]*
element.IntElement:nonGroundIntElement:#[i-n]
element.StringPosition:nonGroundFromString:[i-n]
element.IntElement:groundIntElement:#[0-9]+
element.StringPosition:groundFromString:[0-9]+
element.IntElement:nonGroundIntElement:p[0-9]
element.IntElement:nonGroundIntElement:p
element.IntElement:nonGroundIntElement:e[0-9]
element.IntElement:nonGroundIntElement:e
element.IntElement:nonGroundIntElement:#p[0-9]
element.IntElement:nonGroundIntElement:#p
element.IntElement:nonGroundIntElement:#e[0-9]
element.IntElement:nonGroundIntElement:#e
element.SumOfIntegersExpression:fromString:#[0-9ei-kp\+\-#]+
element.SumOfPositionsExpression:fromString:[0-9i-k\+\-]+
element.SymbolSequence:fromString:alpha
element.SymbolSequence:fromString:beta
element.SymbolSequence:fromString:gamma
element.Dot:fromString:\.
element.SpecialElement:fromString:RegionDone
element.SpecialElement:fromString:Process
element.SpecialElement:fromString:Parse
element.SpecialElement:fromString:Terminal
element.SpecialElement:fromString:Nonterminal
element.Symbol:fromString:S
element.SentenceLengthExpression:fromString:length
element.predicate.IdentityExpression:fromString:Identity[\ 0-9a-zA-Z\(\)\;\-]+
element.predicate.NotExpression:fromString:Not[\ 0-9a-z\.A-Z\(\)\;\-#\+]+
element.predicate.IsTerminalExpression:fromString:Is-terminal[\ 0-9a-zA-Z\(\)\;\-]+
element.predicate.LessThanExpression:fromString:Less-than[\ 0-9a-zA-Z\(\)\;\-#]+
element.predicate.LessThanExpression:fromString:LT[\ 0-9\.a-zA-Z\(\)\;\-#\+]+
element.predicate.LessThanOrEqualExpression:fromString:LE[\ 0-9\.a-zA-Z\(\)\;\-#\+]+
element.GetIntegerBeanPropertyExpression:fromString:engine\.[a-zA-Z]+
@end_elements

@agenda_class agenda.LastElementPriorityQueueAgenda
@engine_class engine.SelectiveRegionalErrorCorrectingDeductiveEngine

@step RegionalEarleyInitter
----------------------------- S -> alpha
[ Parse , S -> . alpha , 0 , 0 , #0 ]

@step OptRegionalEarleyPredictor0
[ Parse , A -> alpha . B beta , i , j , #e ]
------------------------------------- B -> 
[ Parse , B -> . , j , j , #0 ]

@step OptRegionalEarleyPredictor1
[ Parse , A -> alpha . B beta , i , j , #e ]
------------------------------------- B -> C
[ Parse , B -> . C , j , j , #0 ]

@step OptRegionalEarleyPredictor2
[ Parse , A -> alpha . B beta , i , j , #e ]
------------------------------------- B -> C D
[ Parse , B -> . C D , j , j , #0 ]

@step OptRegionalEarleyPredictor3
[ Parse , A -> alpha . B beta , i , j , #e ]
------------------------------------- B -> C D E gamma
[ Parse , B -> . C D E gamma , j , j , #0 ]

@step RegionalEarleyCompleter
[ Parse , A -> alpha . B beta , i , j , #e1 ]
[ Nonterminal , B , j , k , #e2 ]
------------------------------------------------- / Not( LT( engine.errorCount; #e1+#e2 ) )
[ Parse , A -> alpha B . beta , i , k , #e1+#e2 ]

@step OptEarleyLinearizer
[ Parse , B -> gamma . , j , k , #e ]
---------------------------------
[ Nonterminal , B , j , k , #e ]

@step RegionalEarleyScanner
[ Parse , A -> alpha . B beta , i , j , #e ]
[ Terminal , B , j , j+1 , #0 ]
---------------------------------
[ Parse , A -> alpha B . beta , i , j+1 , #e ]

@step RegionalSubstitutionErrorScanner
[ Parse , A -> alpha . B beta , i , j , #e ]
[ Terminal , C , j , j+1 , #0 ]
------------------------------------------------ / Is-terminal(B) , Not( Identity(B;C) ) , Not( LT( engine.errorCount; #e+#1 ) )
[ Parse , A -> alpha B . beta , i , j+1 , #e+#1 ]

@step RegionalInsertionErrorScanner
[ Parse , A -> alpha . B beta , i , j , #e ]
[ Terminal , C , j , j+1 , #0 ]
------------------------------------------------ / Is-terminal(B) , Not( LT( engine.errorCount; #e+#1 ) )
[ Parse , A -> alpha . B beta , i , j+1 , #e+#1 ]

@step RegionalDeletionErrorScanner
[ Parse , A -> alpha . B beta , i , j , #e ]
------------------------------------------------ / Is-terminal(B) , Not( LT( engine.errorCount; #e+#1 ) )
[ Parse , A -> alpha B . beta , i , j	, #e+#1 ]

@step PriorityAdder
[ A , i , j ]
------------------
[ Terminal , A , i , j , #0 ]

@goal [ Parse , S -> alpha . , 0 , length , #e ]