package element;

/**
 * Interfaz que cumplen todos los elementos que pueden aparecer en los esquemas de
 * anlisis sintctico.
 * @author carlos
 *
 * Created at regulus, 07-may-2005 12:42:22
 */
public interface Element
{
	
	/**
	 * Nos dice si el elemento est instanciado (ground) o no.
	 * @return true si el elemento es constante/instanciado (ground), false de lo contrario.
	 */
	public boolean isGround();
	
	/**
	 * Soporte para el patrn Visitor (Visitante).
	 * @param v Visitante de elementos que realiza alguna operacin sobre elementos.
	 */
	public void accept ( ElementVisitor v );
	
	/**
	 * Nos devuelve los elementos hoja de ste, es decir, el propio elemento si es
	 * simple o las hojas del rbol que parte de l si es compuesto.
	 * @return Elementos hoja contenidos en este elemento.
	 */
	public java.util.List getLeafElements();
	
}
