/*
 * Created at regulus on 15-sep-2004 23:24:32
 * as file SumOfIntegersExpression.java on package element
 */
package element;

import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.regex.Pattern;

import parser.eparser.ElementParseException;
import parser.eparser.ElementParser;

/**
 * @author carlos
 *
 * Created at regulus, 15-sep-2004 23:24:32
 */
public class InfoTextConcatenationExpression extends ExpressionElement 
{

	/**
	 * @param children Sumandos de esta concatenacin de cadenas de texto.
	 */
	public InfoTextConcatenationExpression(Element[] children) 
	{
		super(children);
	}

    /**
     * La expresin concatenacin de cadenas de texto devuelve una concatenacin
     * de cadenas Java.
     */
	public String getExpressionCode(String[] memberNames) 
	{
        StringBuffer result = new StringBuffer("");
        result.append("InfoTextElement.groundFromValue(");
        result.append("\"\"");
        for ( int i = 0 ; i < memberNames.length ; i++ )
        {
           	result.append("+");
           	result.append("(");
           	result.append(memberNames[i]);
           	result.append(".toString()");
           	result.append(")");
        }
        result.append(")");
        return result.toString();
	}
	
    public boolean isGround ()
    {
        return false;
    }
    
    /**
     * La clase resultante de una expresin de tipo concatenacin de
     * InfoTextElements es un InfoTextElement.
     */
    public Class getResultingClass()
    {
        return InfoTextElement.class;
    }

    /**
     * Obtiene una expresin concatenacin de cadenas a partir de la cadena que
     * la representa.
     * @param sparm Cadena representando una expresin de concatenacin.
     * @return Elemento correspondiente de tipo InfoTextConcatenationExpression.
     */
    public static InfoTextConcatenationExpression fromString ( String sparm ) throws ElementParseException
    {    	
    	StringTokenizer st1 = new StringTokenizer(sparm,"+",false);
		ArrayList children = new ArrayList();
    	while ( st1.hasMoreTokens() )
    	{
    		String tok = st1.nextToken().trim();
    		if ( tok.equals(sparm) )
    			throw new ElementParseException("Expression \"" + sparm + "\" was being parsed like an InfoTextConcatenationExpression, but doesn't seem like one.");
    		children.add(ElementParser.getCurrentInstance().parse(tok));
    	}
    	return new InfoTextConcatenationExpression( (Element[])children.toArray(new Element[0]) );
    }
    
}
