/*
 * Created at regulus on 26-nov-2004 20:29:09
 * as file Unifier.java on package element.unification
 */
package element.unification;

import java.util.ArrayList;

/**
 * @author carlos
 *
 * Representa una lista de sustituciones de variables para convertir un Term en otro.
 *
 * Created at regulus, 26-nov-2004 20:29:09
 */
public class Unifier 
{

	private ArrayList substitutionSources = new ArrayList();
	private ArrayList substitutionDests = new ArrayList();
	
	public void add ( Term t1 , Term t2 )
	{
		substitutionSources.add(t1);
		substitutionDests.add(t2);
	}
	
	//may modify t!
	public Term apply ( Term t )
	{
		for ( int i = 0 ; i < substitutionSources.size() ; i++ )
		{
			if ( t.equals(substitutionSources.get(i)))
				return (Term) substitutionDests.get(i);
			else 
				t.applySubstitution((Term)substitutionSources.get(i),(Term)substitutionDests.get(i));
		}
		return t;
	}
	
	void applySubstitution ( Term t1 , Term t2 )
	{
		for ( int i = 0 ; i < substitutionSources.size() ; i++ )
		{
			Term t = (Term) substitutionSources.get(i);
			t.applySubstitution(t1,t2);
		}
		for ( int i = 0 ; i < substitutionDests.size() ; i++ )
		{
			Term t = (Term) substitutionDests.get(i);
			t.applySubstitution(t1,t2);
		}
	}
	
	public String toString()
	{
		StringBuffer sb = new StringBuffer("[");
		for ( int i = 0 ; i < substitutionSources.size() ; i++ )
		{ 
			if ( i > 0 ) sb.append(",");
			sb.append(substitutionSources.get(i) + " = " + substitutionDests.get(i));
		}
		sb.append("]");
		return new String(sb);
	}

}
