package grammar.tag.util;

import java.util.Set;
import java.util.TreeSet;

import org.w3c.dom.Element;

import util.DOMNodeWrapper;

public class DuplicateTreeRenamerUndoer extends AbstractGrammarTransformer
{

	
	public String toString()
	{
		return "Re-renaming duplicate trees to original names";
	}
	
	
	
	public DuplicateTreeRenamerUndoer(String inFile, String outFile, AbstractGrammarTransformer next) 
	{
		super(inFile, outFile, next);
	}

	public DuplicateTreeRenamerUndoer(String inFile, String outFile) 
	{
		super(inFile, outFile);
	}

	public DuplicateTreeRenamerUndoer(AbstractGrammarTransformer next) 
	{
		super(next);
	}
	
	
	public void preprocessTreeNode(DOMNodeWrapper treeNode)
	{
		String name = treeNode.getAttribute("name");
		while ( name.endsWith("DUP1") )
			name = name.substring(0,name.length()-4);
		((Element)treeNode.getNode()).setAttribute("name",name);
	}

}
