/* Generated By:JavaCC: Do not edit this line. SchemaParser.java */
package parser.sparser; //schema parser package
import java.util.*;
import parser.eparser.*; //element parser
import parser.sparser.tree.*; //parse tree
import java.io.*;

public class SchemaParser implements SchemaParserConstants {

        public static ElementParser ep; /*Used by Element() parsing method*/

        /**Configuration**/
        private static boolean verboseOutput=true;
        private static String outputDirectory="generated/";
        private static String elementFile="elements.txt";
        private static String defaultGrammarClassName="grammar.ContextFreeGrammar";
        private static String defaultAgendaClassName="agenda.SimpleQueueAgenda";
        private static String defaultEngineClassName="engine.StandardDeductiveEngine";

        public static void setVerbose ( boolean verbose )
        {
                verboseOutput=verbose;
        }
        public static void setOutputDirectory ( String outputDir )
        {
                if ( outputDir.endsWith(File.separator) )
                        outputDirectory = outputDir;
                else
                        outputDirectory = outputDir+File.separator;
        }
        public static void setElementFile ( String eltFile )
        {
                elementFile = eltFile;
        }
        public static void setDefaultGrammarClassName ( String name )
        {
                defaultGrammarClassName = name;
        }
        public static void setDefaultAgendaClassName ( String name )
        {
                defaultAgendaClassName = name;
        }
        public static void setDefaultEngineClassName ( String name )
        {
                defaultEngineClassName = name;
        }

  public static void main( String [] args ) throws ParseException , ElementSpecFormatException
  {


                ep = new ElementParser();


                SchemaParser parser = new SchemaParser(System.in);
        SchemaNode sn = parser.Schema( );


    (new generator.CodeGenerator(sn,verboseOutput,outputDirectory)).generateCode();

  }

  static final public SchemaNode Schema() throws ParseException, ElementSpecFormatException, ParseException {
        ArrayList stepsList = new ArrayList(); //pasos deductivos, tanto normales como meta
        String name;
        Class grammarClass = null;
        Class agendaClass = null;
        String engineClassName = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELTSHEADER:
      ElementDefinitionList();
      break;
    default:
      jj_la1[0] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case GRAMMARCLASSHEADER:
      grammarClass = GrammarClassSpecification();
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AGENDACLASSHEADER:
      agendaClass = AgendaClassSpecification();
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ENGINECLASSHEADER:
      engineClassName = EngineClassSpecification();
      break;
    default:
      jj_la1[3] = jj_gen;
      ;
    }
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STEPHEADER:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_1;
      }
      name = StepName();
      StepDesc(name,stepsList);
    }
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GOALHEADER:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_2;
      }
      jj_consume_token(GOALHEADER);
      GoalDesc(stepsList);
    }
    jj_consume_token(0);
                SchemaNode sn = new SchemaNode( (DeductiveStepNode[])stepsList.toArray(new DeductiveStepNode[0]) );
                if ( grammarClass != null )
                        sn.setGrammarClass ( grammarClass );
                else
                {
                        try
                        {
                                Class cl = Class.forName(defaultGrammarClassName);
                                sn.setGrammarClass(cl);
                        }
                        catch ( Exception e )
                        {
                                System.err.println("[WARNING] Default grammar class " + defaultGrammarClassName + " couldn't be loaded. Internal default will be used instead.");
                        }
                }
                if ( agendaClass != null )
                        sn.setAgendaClass ( agendaClass );
                else
                {
                        try
                        {
                                Class cl = Class.forName(defaultAgendaClassName);
                                sn.setAgendaClass(cl);
                        }
                        catch ( Exception e )
                        {
                                System.err.println("[WARNING] Default agenda class " + defaultAgendaClassName + " couldn't be loaded. Internal default will be used instead.");
                        }
                }
                if ( engineClassName != null )
                        sn.setEngineClassName ( engineClassName );
                else
                        sn.setEngineClassName(defaultEngineClassName);
                {if (true) return sn;}
    throw new Error("Missing return statement in function");
  }

  static final public void ElementDefinitionList() throws ParseException, ElementSpecFormatException {
    jj_consume_token(ELTSHEADER);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT_DEFINITION:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_3;
      }
      ElementDefinition();
    }
    jj_consume_token(ELTSFOOTER);
          //after parsing the custom element definitions, add the predefined ones.
                try
        {
                SchemaParser.ep.addFile(new File(elementFile));
        }
                catch ( ElementSpecFormatException esfe )
                {
                        {if (true) throw new ParseException("Element formats are not well-defined: " + esfe.getMessage());}
                }
                catch ( FileNotFoundException fnfe )
                {
                        {if (true) throw new ParseException("Lacking element format file " + elementFile);}
                }
                catch ( IOException ioe )
                {
                        {if (true) throw new ParseException("Input/Output Exception on reading element format file " + elementFile);}
                }
  }

  static final public void ElementDefinition() throws ParseException, ElementSpecFormatException {
        Token tok;
    tok = jj_consume_token(ELEMENT_DEFINITION);
                SchemaParser.ep.addLine ( tok.image.trim() );
  }

  static final public Class GrammarClassSpecification() throws ParseException, ParseException {
         Token classNameToken;
    jj_consume_token(GRAMMARCLASSHEADER);
    classNameToken = jj_consume_token(CLASSNAME);
                Class cl;
                try
                {
                        cl = Class.forName ( classNameToken.image.trim() );
                        if ( !grammar.Grammar.class.isAssignableFrom ( cl ) )
                        {
                                {if (true) throw new ParseException ( "Wrong grammar class specification: class " + classNameToken.image + " was found, but doesn't implement the interface Grammar." );}
                        }
                        {if (true) return cl;}
                }
                catch ( Exception exc )
                {
                        {if (true) throw new ParseException ( "Wrong grammar class specification: class " + classNameToken.image + " can't be loaded." );}
                }
    throw new Error("Missing return statement in function");
  }

  static final public String EngineClassSpecification() throws ParseException, ParseException {
         Token classNameToken;
    jj_consume_token(ENGINECLASSHEADER);
    classNameToken = jj_consume_token(CLASSNAME);
                {if (true) return classNameToken.image.trim();} //return the class name

    throw new Error("Missing return statement in function");
  }

  static final public Class AgendaClassSpecification() throws ParseException, ParseException {
         Token classNameToken;
    jj_consume_token(AGENDACLASSHEADER);
    classNameToken = jj_consume_token(CLASSNAME);
                Class cl;
                try
                {
                        cl = Class.forName ( classNameToken.image.trim() );
                        if ( !agenda.Agenda.class.isAssignableFrom ( cl ) )
                        {
                                {if (true) throw new ParseException ( "Wrong agenda class specification: class " + classNameToken.image + " was found, but doesn't implement the interface Agenda." );}
                        }
                        {if (true) return cl;}
                }
                catch ( Exception exc )
                {
                        {if (true) throw new ParseException ( "Wrong agenda class specification: class " + classNameToken.image + " can't be loaded." );}
                }
    throw new Error("Missing return statement in function");
  }

  static final public String StepName() throws ParseException {
        Token identifier;;
    jj_consume_token(STEPHEADER);
    identifier = jj_consume_token(ID);
                {if (true) return identifier.image.trim();}
    throw new Error("Missing return statement in function");
  }

  static final public DeductiveStepNode StepDesc(String stepName , List stepsList) throws ParseException {
        AntecedentNode antec;
        AntecedentNode negations; //negated items in antecedent
        ItemNode conditions;
        ItemNode predicates = null;
        ParseTreeNode conseq;
        DeductiveStepNode result;
    antec = Antec();
    jj_consume_token(GUIONES);
    conditions = Conditions();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SLASH:
      jj_consume_token(SLASH);
      predicates = Conditions();
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
    conseq = Conseq();
                List negatedItems = new ArrayList();
                List requiredItems = new ArrayList();

                //remove negated items from antecedent and add them to negated items list
                for ( int i = antec.numChildren()-1 ; i >= 0 ; i-- )
                {
                        ItemNode aNode = (ItemNode) antec.getChild(i);
                        if ( aNode.isNegated() )
                        {
                                negatedItems.add(aNode);
                        }
                        else
                        {
                                requiredItems.add(aNode);
                        }
                }
                antec = new AntecedentNode( requiredItems.toArray() ); //this antecedent is the same as the former but without the negated items
                negations = new AntecedentNode ( negatedItems.toArray() );

                if ( predicates == null ) predicates = new ItemNode ( new Object[0] );
                result = new DeductiveStepNode ( stepName , antec , negations , conseq , conditions , predicates , false );
                if ( stepsList != null ) stepsList.add(result);
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public DeductiveStepNode GoalDesc(List stepsList) throws ParseException {
        AntecedentNode antec;
        DeductiveStepNode result;
    antec = Antec();
                result = new DeductiveStepNode ( "GoalCondition" , antec , new AntecedentNode(new Object[0]) , new ItemNode( new Object[0] ) , new ItemNode( new Object[0] ) , new ItemNode( new Object[0] ) , true );
                if ( stepsList != null ) stepsList.add(result);
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public AntecedentNode Antec() throws ParseException {
        List itemList = new ArrayList();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FORALLHEADER:
      case NOTHEADER:
      case LCOR:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_4;
      }
      ItemDesc(itemList);
    }
                {if (true) return new AntecedentNode(itemList.toArray());}
    throw new Error("Missing return statement in function");
  }

  static final public ParseTreeNode Conseq() throws ParseException {
        ParseTreeNode ptn;
    ptn = ItemDesc(null);
                {if (true) return ptn;}
    throw new Error("Missing return statement in function");
  }

  static final public ParseTreeNode ItemDesc(java.util.List itemList) throws ParseException {
        ParseTreeNode result; //may be an ItemNode or a ForallScopeNode
        ForallNode n1 = null;
        ParseTreeNode n2 = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FORALLHEADER:
      n1 = Forall();
      n2 = ItemDesc(itemList);
                result = new ForallScopeNode(n1,n2);
                if ( itemList != null ) itemList.add(result);
                {if (true) return result;}
      break;
    case LCOR:
      jj_consume_token(LCOR);
      result = ElementList();
      jj_consume_token(RCOR);
                if ( itemList != null ) itemList.add(result);
                {if (true) return result;}
      break;
    case NOTHEADER:
      jj_consume_token(NOTHEADER);
      jj_consume_token(LCOR);
      result = ElementList();
      jj_consume_token(RCOR);
                ((ItemNode)result).setNegated ( true );
                if ( itemList != null ) itemList.add(result);
                {if (true) return result;}
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final public ItemNode ElementList() throws ParseException {
        List elementsList = new ArrayList();
    if (jj_2_1(2)) {
      ElementWrapper(elementsList);
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMA:
          ;
          break;
        default:
          jj_la1[10] = jj_gen;
          break label_5;
        }
        jj_consume_token(COMA);
        ElementWrapper(elementsList);
      }
    } else {
      ;
    }
                {if (true) return new ItemNode(elementsList.toArray());}
    throw new Error("Missing return statement in function");
  }

  static final public ParseTreeNode ElementWrapper(java.util.List elementList) throws ParseException {
        ElementNode elt = null;
        ForallNode fn = null;
        ForallScopeNode fsn = null;
        ParseTreeNode result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ID:
    case CLASSNAME:
    case ELEMENT_TOKEN:
      elt = Element();
                if ( elementList != null ) elementList.add(elt);
                {if (true) return elt;}
      break;
    case FORALLHEADER:
      fn = Forall();
      elt = Element();
                result = new ForallScopeNode ( fn , elt );
                if ( elementList != null ) elementList.add(result);
                {if (true) return result;}
      break;
    default:
      jj_la1[11] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final public ForallNode Forall() throws ParseException {
        ElementNode symbol,dlimit,ulimit;
    jj_consume_token(FORALLHEADER);
    symbol = Element();
    jj_consume_token(IGUAL);
    dlimit = Element();
    jj_consume_token(PUNTOS);
    ulimit = Element();
                {if (true) return new ForallNode ( symbol , dlimit , ulimit );}
    throw new Error("Missing return statement in function");
  }

  static final public ItemNode Conditions() throws ParseException {
        ItemNode in;
    in = ElementList();
                {if (true) return in;}
    throw new Error("Missing return statement in function");
  }

  static final public ElementNode Element() throws ParseException {
        Token tok;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_TOKEN:
      //el famoso Element
              tok = jj_consume_token(ELEMENT_TOKEN);
                //aqu se llama a la funcin para parsear Elements, en funcin de las regex's definidas
                //por el usuario.


                try
                {
                        {if (true) return new ElementNode( SchemaParser.ep.parse ( tok.image.trim() ) );}
                }
                catch ( ElementParseException epe )
                {
                        {if (true) throw new ParseException( epe.getMessage() );}
                }
      break;
    case ID:
      tok = jj_consume_token(ID);
                try
                {
                        {if (true) return new ElementNode( SchemaParser.ep.parse ( tok.image.trim() ) );}
                }
                catch ( ElementParseException epe )
                {
                        {if (true) throw new ParseException( epe.getMessage() );}
                }
      break;
    case CLASSNAME:
      tok = jj_consume_token(CLASSNAME);
                try
                {
                        {if (true) return new ElementNode( SchemaParser.ep.parse ( tok.image.trim() ) );}
                }
                catch ( ElementParseException epe )
                {
                        {if (true) throw new ParseException( epe.getMessage() );}
                }
      break;
    default:
      jj_la1[12] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  static final private boolean jj_3_1() {
    if (jj_3R_6()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_7()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_7() {
    if (jj_scan_token(COMA)) return true;
    return false;
  }

  static final private boolean jj_3R_13() {
    if (jj_scan_token(ID)) return true;
    return false;
  }

  static final private boolean jj_3R_9() {
    if (jj_3R_11()) return true;
    return false;
  }

  static final private boolean jj_3R_6() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_8()) {
    jj_scanpos = xsp;
    if (jj_3R_9()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_8() {
    if (jj_3R_10()) return true;
    return false;
  }

  static final private boolean jj_3R_14() {
    if (jj_scan_token(CLASSNAME)) return true;
    return false;
  }

  static final private boolean jj_3R_11() {
    if (jj_scan_token(FORALLHEADER)) return true;
    if (jj_3R_10()) return true;
    return false;
  }

  static final private boolean jj_3R_10() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_12()) {
    jj_scanpos = xsp;
    if (jj_3R_13()) {
    jj_scanpos = xsp;
    if (jj_3R_14()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_12() {
    if (jj_scan_token(ELEMENT_TOKEN)) return true;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public SchemaParserTokenManager token_source;
  static SimpleCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[13];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x100000,0x20000,0x40000,0x80000,0x8000,0x10000,0x4000,0x4000000,0x1600000,0x1600000,0x20000000,0x200000,0x0,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x7,0x7,};
   }
  static final private JJCalls[] jj_2_rtns = new JJCalls[1];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public SchemaParser(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new SchemaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 13; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 13; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public SchemaParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new SchemaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 13; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 13; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public SchemaParser(SchemaParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 13; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(SchemaParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 13; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  static final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[35];
    for (int i = 0; i < 35; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 13; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 35; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 1; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
