package parser.sparser.tree;
//representa p.ej. "for i=1..n"
/**
 * Nodo que representa una estructura tipo "for i=1..n", para
 * futuras extensiones.
 */
public class ForallNode implements ParseTreeNode
{

	//multiple items specified by a forall-type expression
	private ElementNode symbol;
	private ElementNode dlimit; //a constant, int element (will later be an int for efficiency??)
	private ElementNode ulimit; //a constant, int element
	public ForallNode ( ElementNode symbol , ElementNode dlimit , ElementNode ulimit )
	{
		this.symbol = symbol;
		this.dlimit = dlimit;
		this.ulimit = ulimit;
	}
	
	public String toString()
	{
		return "for " + symbol.toString() + " = " + dlimit.toString() + ".." + ulimit.toString();
	}
	
	public int numChildren()
	{
		return 3;
	}
	
	public ParseTreeNode getChild(int i)
	{
		switch(i)
		{
			case 0: return symbol;
			case 1: return dlimit;
			case 2: return ulimit;
			default: return null;
		}
	}
	
}