package parser.sparser.tree;

/**
 * representa p.ej. "for i=1..n [A,i,i+1]".
 */
public class ForallScopeNode implements ParseTreeNode
{
	private ForallNode firstNode;
	private ParseTreeNode secondNode; //which may be an ItemNode, an Element or another ForallScopeNode
	public ForallScopeNode ( ForallNode firstNode , ParseTreeNode secondNode )
	{
		this.firstNode = firstNode;
		this.secondNode = secondNode;
	}
	
	public String toString()
	{
		return firstNode.toString() + secondNode.toString();
	}
	
	public int numChildren()
	{
		return 2;
	}
	
	public ParseTreeNode getChild(int i)
	{
		switch(i)
		{
			case 0: return firstNode;
			case 1: return secondNode;
			default: return null;
		}
	}
	
}
